
<%= simple_form_for(@video) do |f| %>
  <%= f.error_notification %>
  <%= f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present? %>

  <div class="form-inputs">
    <%= f.input :title %>
    <%= f.input :description %>
    <%= f.input :file, as: :file %>
  </div>

  <div class="form-actions">
    <%= f.button :submit %>
  </div>
<% end %>

<br>
<br>


<video id="video" autoplay></video>
<button id="start">Start Recording</button>
<button id="stop">Stop Recording</button>

<script src="https://cdn.jsdelivr.net/npm/recordrtc"></script>


<script>
  var recorder;
  var video = document.getElementById("video");
  var start = document.getElementById("start");
  var stop = document.getElementById("stop");

  start.addEventListener("click", function() {
    navigator.mediaDevices.getUserMedia({audio: true, video: true}).then(function(stream) {
      video.srcObject = stream;
      recorder = RecordRTC(stream, {type: "video"});
      recorder.startRecording();
    });
  });

  stop.addEventListener("click", function() {
    recorder.stopRecording(function() {
      var blob = recorder.getBlob();
      var formData = new FormData();
      formData.append('video[file]', blob, "video.webm");
      formData.append('authenticity_token', '<%= form_authenticity_token %>');

        fetch('/videos', {
          method: 'POST',
          body: formData,
          headers: {
            'X-CSRF-Token': '<%= form_authenticity_token %>'
          }
        }).then(response => {
          // handle the response
        });
        
      var xhr = new XMLHttpRequest();
      xhr.open("POST", "/videos", true);
      xhr.send(formData);
    });
  });
</script>
